//+------------------------------------------------------------------+
//|                                          TMS Angleator v3.00.mq4 |
//|                                                     Griffin Soul |
//|                         http://www.forexfactory.com/griffinssoul |
//+------------------------------------------------------------------+
#property copyright "Griffin Soul"
#property link      "http://www.forexfactory.com/griffinssoul"
#property link      "www.forx-tsd.com"
#property version   "3.00"
#property strict
#property indicator_chart_window

// External settings

extern color Text_Color = clrBlack;
extern color Back_Ground_Color = clrIvory;
extern color Arrow_Bull = clrGreen;
extern color Neutral_Arrow = clrBlack;
extern bool  trans_back = false;
extern color Arrow_Bear = clrRed;
extern color Over_brought = clrGreen;
extern color Over_sold = clrRed;
extern color Above_fifty = clrLightGreen;
extern color Below_fifty = clrOrange;
extern string Font_Type = "Times New";
extern int Font_Size = 8;
extern double TDI_cross_threshold = 1.00; // TDI cross happens within Green/Red line separation less than 1.00 (default)
extern double TDI_normal_threshold = 5.00; // Separation is normal for values less than 5.00 (default) & strong > 5.00
extern int Window = 0;
extern int Corner = 3;

// Global declarations   

double GreenAngle;
double RedAngle;
double ratio;
double GreenAngle_HX;
double RedAngle_HX;
double test_TdiDistance;
double convert2pips;
string ratio_display;
string Tdi_signal_buysell;
string Tdi_cross_H1;
string Tdi_cross_H4;
string Tdi_cross_D1;
string degree_display;
string TdiDistance;
string Tdi_cross_HX;
string Tdi_zone_HX;
color wing_color_HX;
color zone_color_HX;
int   Expand_X = 240;

   //---
// Start 
//---
int start()
{
      
//---Panel Ratio
Panel_Ratio();

   ObjectCreate("panel_height", OBJ_LABEL,Window, 0, 0);
      ObjectSet("panel_height", OBJPROP_CORNER, Corner);
      ObjectSet("panel_height", OBJPROP_XDISTANCE, 10);
      ObjectSet("panel_height", OBJPROP_YDISTANCE, 10); 
   ObjectSetText("panel_height",  "Panel Ratio: " +ratio_display, Font_Size, Font_Type, Text_Color);      
      
//---Angles    
Current_Angles();  
   ObjectCreate("TDIAngle", OBJ_LABEL, Window, 0, 0);
      ObjectSet("TDIAngle", OBJPROP_CORNER, Corner);
      ObjectSet("TDIAngle", OBJPROP_XDISTANCE, 10);
      ObjectSet("TDIAngle", OBJPROP_YDISTANCE, 25);
   ObjectSetText("TDIAngle", "TDI Rel Angle: " +degree_display + " Green: " +(string)GreenAngle + " Red: " +(string)RedAngle , Font_Size, Font_Type, Text_Color);
    
//---Separation   
Seperation();
   ObjectCreate("tdi_angle", OBJ_LABEL,Window, 0, 0);
      ObjectSet("tdi_angle", OBJPROP_CORNER,Corner);
      ObjectSet("tdi_angle", OBJPROP_XDISTANCE, 10);
      ObjectSet("tdi_angle", OBJPROP_YDISTANCE, 40);          
   ObjectSetText("tdi_angle",  "TDI Separation: " +TdiDistance, Font_Size, Font_Type, Text_Color);   
   
//---(M15,M30,1H,4H,D1) Arrow Directions  

//---15
Arrow_Directions(PERIOD_M5); TDI_Green_Zone(PERIOD_M5);

ObjectCreate("honesign5",OBJ_LABEL,Window,0,0);
   ObjectSet("honesign5",OBJPROP_CORNER,Corner);
   ObjectSet("honesign5",OBJPROP_XDISTANCE,215);
   ObjectSet("honesign5",OBJPROP_YDISTANCE,70); 
ObjectSetText("honesign5","M5",Font_Size,Font_Type,Text_Color);      

ObjectCreate("onesign5",OBJ_LABEL,Window,0,0);
   ObjectSet("onesign5",OBJPROP_CORNER,Corner);
   ObjectSet("onesign5",OBJPROP_BACK,false);
   ObjectSet("onesign5",OBJPROP_XDISTANCE,215);
   ObjectSet("onesign5",OBJPROP_YDISTANCE,90); 
ObjectSetText("onesign5", Tdi_cross_HX, 12,"Wingdings", wing_color_HX);  

ObjectCreate("fifty5",OBJ_LABEL,Window,0,0);
   ObjectSet("fifty5",OBJPROP_CORNER,Corner);
   ObjectSet("fifty5",OBJPROP_BACK,false);
   ObjectSet("fifty5",OBJPROP_XDISTANCE,215);
   ObjectSet("fifty5",OBJPROP_YDISTANCE,120); 
ObjectSetText("fifty5", Tdi_zone_HX, 12,"Wingdings", zone_color_HX);  

Arrow_Directions(PERIOD_M15); TDI_Green_Zone(PERIOD_M15);

ObjectCreate("honesign15",OBJ_LABEL,Window,0,0);
   ObjectSet("honesign15",OBJPROP_CORNER,Corner);
   ObjectSet("honesign15",OBJPROP_XDISTANCE,180);
   ObjectSet("honesign15",OBJPROP_YDISTANCE,70); 
ObjectSetText("honesign15","M15",Font_Size,Font_Type,Text_Color);      

ObjectCreate("onesign15",OBJ_LABEL,Window,0,0);
   ObjectSet("onesign15",OBJPROP_CORNER,Corner);
   ObjectSet("onesign15",OBJPROP_BACK,false);
   ObjectSet("onesign15",OBJPROP_XDISTANCE,180);
   ObjectSet("onesign15",OBJPROP_YDISTANCE,90); 
ObjectSetText("onesign15", Tdi_cross_HX, 12,"Wingdings", wing_color_HX);  

ObjectCreate("fifty15",OBJ_LABEL,Window,0,0);
   ObjectSet("fifty15",OBJPROP_CORNER,Corner);
   ObjectSet("fifty15",OBJPROP_BACK,false);
   ObjectSet("fifty15",OBJPROP_XDISTANCE,180);
   ObjectSet("fifty15",OBJPROP_YDISTANCE,120); 
ObjectSetText("fifty15", Tdi_zone_HX, 12,"Wingdings", zone_color_HX);  

//---30
Arrow_Directions(PERIOD_M30); TDI_Green_Zone(PERIOD_M30);

ObjectCreate("honesign30",OBJ_LABEL,Window,0,0);
   ObjectSet("honesign30",OBJPROP_CORNER,Corner);
   ObjectSet("honesign30",OBJPROP_XDISTANCE,145);
   ObjectSet("honesign30",OBJPROP_YDISTANCE,70); 
ObjectSetText("honesign30","M30",Font_Size,Font_Type,Text_Color);      

ObjectCreate("onesign30",OBJ_LABEL,Window,0,0);
   ObjectSet("onesign30",OBJPROP_CORNER,Corner);
   ObjectSet("onesign30",OBJPROP_BACK,false);
   ObjectSet("onesign30",OBJPROP_XDISTANCE,145);
   ObjectSet("onesign30",OBJPROP_YDISTANCE,90); 
ObjectSetText("onesign30", Tdi_cross_HX, 12,"Wingdings", wing_color_HX);  

ObjectCreate("fifty30",OBJ_LABEL,Window,0,0);
   ObjectSet("fifty30",OBJPROP_CORNER,Corner);
   ObjectSet("fifty30",OBJPROP_BACK,false);
   ObjectSet("fifty30",OBJPROP_XDISTANCE,145);
   ObjectSet("fifty30",OBJPROP_YDISTANCE,120); 
ObjectSetText("fifty30", Tdi_zone_HX, 12,"Wingdings", zone_color_HX);  

//---H1 
Arrow_Directions(PERIOD_H1); TDI_Green_Zone(PERIOD_H1);

ObjectCreate("honesign",OBJ_LABEL,Window,0,0);
   ObjectSet("honesign",OBJPROP_CORNER,Corner);
   ObjectSet("honesign",OBJPROP_XDISTANCE,110);
   ObjectSet("honesign",OBJPROP_YDISTANCE,70); 
ObjectSetText("honesign","H1",Font_Size,Font_Type,Text_Color);      

ObjectCreate("onesign",OBJ_LABEL,Window,0,0);
   ObjectSet("onesign",OBJPROP_CORNER,Corner);
   ObjectSet("onesign",OBJPROP_BACK,false);
   ObjectSet("onesign",OBJPROP_XDISTANCE,110);
   ObjectSet("onesign",OBJPROP_YDISTANCE,90); 
ObjectSetText("onesign", Tdi_cross_HX, 12,"Wingdings", wing_color_HX);  

ObjectCreate("fiftyH1",OBJ_LABEL,Window,0,0);
   ObjectSet("fiftyH1",OBJPROP_CORNER,Corner);
   ObjectSet("fiftyH1",OBJPROP_BACK,false);
   ObjectSet("fiftyH1",OBJPROP_XDISTANCE,110);
   ObjectSet("fiftyH1",OBJPROP_YDISTANCE,120); 
ObjectSetText("fiftyH1", Tdi_zone_HX, 12,"Wingdings", zone_color_HX);  

//---H4
Arrow_Directions(PERIOD_H4); TDI_Green_Zone(PERIOD_H4);   

ObjectCreate("hfoursign",OBJ_LABEL,Window,0,0);
   ObjectSet("hfoursign",OBJPROP_CORNER,Corner);
   ObjectSet("hfoursign",OBJPROP_XDISTANCE,75);
   ObjectSet("hfoursign",OBJPROP_YDISTANCE,70); 
ObjectSetText("hfoursign","H4",Font_Size,Font_Type,Text_Color);      

ObjectCreate("secondhfour",OBJ_LABEL,Window,0,0);
   ObjectSet("secondhfour",OBJPROP_CORNER,Corner);
   ObjectSet("secondhfour",OBJPROP_BACK,false);
   ObjectSet("secondhfour",OBJPROP_XDISTANCE,75);
   ObjectSet("secondhfour",OBJPROP_YDISTANCE,90); 
ObjectSetText("secondhfour", Tdi_cross_HX, 12,"Wingdings", wing_color_HX);  

ObjectCreate("fiftyH4",OBJ_LABEL,Window,0,0);
   ObjectSet("fiftyH4",OBJPROP_CORNER,Corner);
   ObjectSet("fiftyH4",OBJPROP_BACK,false);
   ObjectSet("fiftyH4",OBJPROP_XDISTANCE,75);
   ObjectSet("fiftyH4",OBJPROP_YDISTANCE,120); 
ObjectSetText("fiftyH4", Tdi_zone_HX, 12,"Wingdings", zone_color_HX);  

//---D1
Arrow_Directions(PERIOD_D1); TDI_Green_Zone(PERIOD_D1);  

ObjectCreate("dailysign",OBJ_LABEL,Window,0,0);
   ObjectSet("dailysign",OBJPROP_CORNER,Corner);
   ObjectSet("dailysign",OBJPROP_XDISTANCE,40);
   ObjectSet("dailysign",OBJPROP_YDISTANCE,70); 
ObjectSetText("dailysign","D1",Font_Size,Font_Type,Text_Color);      

ObjectCreate("dailyfour",OBJ_LABEL,Window,0,0);
   ObjectSet("dailyfour",OBJPROP_CORNER,Corner);
   ObjectSet("dailyfour",OBJPROP_BACK,false);
   ObjectSet("dailyfour",OBJPROP_XDISTANCE,40);
   ObjectSet("dailyfour",OBJPROP_YDISTANCE,90); 
ObjectSetText("dailyfour", Tdi_cross_HX, 12,"Wingdings", wing_color_HX);  

ObjectCreate("fiftyD1",OBJ_LABEL,Window,0,0);
   ObjectSet("fiftyD1",OBJPROP_CORNER,Corner);
   ObjectSet("fiftyD1",OBJPROP_BACK,false);
   ObjectSet("fiftyD1",OBJPROP_XDISTANCE,40);
   ObjectSet("fiftyD1",OBJPROP_YDISTANCE,120); 
ObjectSetText("fiftyD1", Tdi_zone_HX, 12,"Wingdings", zone_color_HX);  
   
// Calculate for ECN / Non-ECN brokers 
      if (Digits == 5 || Digits == 3){    
      convert2pips    = Point*10 ; 
      } 
      else if (Digits == 4 || Digits == 2)
      {    
      convert2pips    = Point;     
      } 

//---
return(0);
}

//--
// Functions
//--
void Panel_Ratio(){  
         double height = (double)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,Window);
         double width = (double)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,Window);
          ratio = NormalizeDouble(width / height, 2);
          ratio_display = DoubleToStr(ratio, 2);
}

void Current_Angles(){  
         double TdiGreen0 = iCustom(Symbol(),0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  4, 0);
         double TdiGreen1 = iCustom(Symbol(),0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  4, 1);
         double TdiRed0 = iCustom(Symbol(),0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  5, 0);
         double TdiRed1 = iCustom(Symbol(),0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  5, 1);
         double TdiGreenDegrees = (MathArctan(TdiGreen0 - TdiGreen1)*180)/3.1415;
         double TdiRedDegrees = (MathArctan(TdiRed0 - TdiRed1)*180)/3.1415;
         double TdiDegree = TdiGreenDegrees/TdiRedDegrees ;      
         double display_degree = NormalizeDouble(TdiDegree, 2);
          degree_display = DoubleToStr(display_degree, 2);
          GreenAngle = NormalizeDouble(TdiGreenDegrees,0);  
          RedAngle = NormalizeDouble(TdiRedDegrees,0); 
}

void Seperation(){
         double TdiGreen0 = iCustom(Symbol(),0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  4, 0);
         double TdiRed0 = iCustom(Symbol(),0, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  5, 0);
          test_TdiDistance = NormalizeDouble(MathAbs(TdiGreen0 - TdiRed0),2);
         //Alert(test_TdiDistance);
         if(test_TdiDistance < TDI_cross_threshold){
            TdiDistance = "Crossing";
            }
         else if(test_TdiDistance > TDI_cross_threshold && test_TdiDistance < TDI_normal_threshold){
            TdiDistance = "Normal";
            }
         else if(test_TdiDistance > TDI_normal_threshold ){
            TdiDistance = "Strong";
            }
}

void Arrow_Directions(int period_HX){
double TdiGreen0_HX = iCustom(Symbol(),period_HX, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  4, 0);
double TdiGreen1_HX = iCustom(Symbol(),period_HX, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  4, 1);
double TdiRed0_HX = iCustom(Symbol(),period_HX, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  5, 0);
double TdiRed1_HX = iCustom(Symbol(),period_HX, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  5, 1);
double TdiGreenDegrees_HX = (MathArctan(TdiGreen0_HX - TdiGreen1_HX)*180)/3.1415;
double TdiRedDegrees_HX = (MathArctan(TdiRed0_HX - TdiRed1_HX)*180)/3.1415;
 GreenAngle_HX = NormalizeDouble(TdiGreenDegrees_HX,0);  
 RedAngle_HX = NormalizeDouble(TdiRedDegrees_HX,0);        
if(GreenAngle_HX > 60.0){
 Tdi_cross_HX = CharToStr(233); 
 wing_color_HX = Arrow_Bull;
}
else if(GreenAngle_HX > 30.0 && GreenAngle_HX <= 60.0){
 Tdi_cross_HX = CharToStr(236); 
 wing_color_HX = Arrow_Bull;
}
else if(GreenAngle_HX < -60.0){
 Tdi_cross_HX = CharToStr(234);
 wing_color_HX = Arrow_Bear;
} 
else if(GreenAngle_HX < -30.0 && GreenAngle_HX >= -60.0){
 Tdi_cross_HX = CharToStr(238);
 wing_color_HX = Arrow_Bear;
} 
else{
 Tdi_cross_HX = CharToStr(232);
 wing_color_HX = Neutral_Arrow;
}
}

void TDI_Green_Zone(int period_HX1){
double TdiGreen0_HX1 = iCustom(Symbol(),period_HX1, "TDI Red Green", 13, 0, 34, 2, 0, 7, 0,  4, 0); 
if(TdiGreen0_HX1 > 68.0){
 Tdi_zone_HX = CharToStr(110); 
 zone_color_HX = Over_brought;
}
else if(TdiGreen0_HX1 > 50.0 && TdiGreen0_HX1 < 68.0){
 Tdi_zone_HX = CharToStr(110); 
 zone_color_HX = Above_fifty;
}
else if(TdiGreen0_HX1 < 50.0 && TdiGreen0_HX1 > 32.0){
 Tdi_zone_HX = CharToStr(110); 
 zone_color_HX = Below_fifty;
}
else if(TdiGreen0_HX1 < 32.0){
 Tdi_zone_HX = CharToStr(110); 
 zone_color_HX = Over_sold;
}
}

//---

//--
// Setup main background box 
//---
int init()
{
   int cadd = 0; if (Corner==2 || Corner==3) cadd = 150;
ObjectCreate(0,"box",OBJ_RECTANGLE_LABEL,Window,0,0,0);
   ObjectSet("box", OBJPROP_CORNER, Corner);
   ObjectSetInteger(0,"box",OBJPROP_BGCOLOR, Back_Ground_Color);
   ObjectSetInteger(0,"box",OBJPROP_XDISTANCE, Expand_X+2);
   ObjectSetInteger(0,"box",OBJPROP_YDISTANCE, 2+cadd);
   ObjectSetInteger(0,"box",OBJPROP_XSIZE, Expand_X);
   ObjectSetInteger(0,"box",OBJPROP_YSIZE, 150);
   ObjectSetInteger(0,"box",OBJPROP_BACK,trans_back);
//---  
return(0);
}

//--
// Deinit everything
//---  
int deinit()
{
   ObjectDelete("TDIAngle");
   ObjectDelete("tdi_angle");
   ObjectDelete("box");
   ObjectDelete("panel_height");
   ObjectDelete("Signal");
   ObjectDelete("honesign");
   ObjectDelete("hfoursign");
   ObjectDelete("onesign");
   ObjectDelete("secondhfour");
   ObjectDelete("dailyfour");
   ObjectDelete("dailysign");
   ObjectDelete("honesign5");
   ObjectDelete("honesign15");
   ObjectDelete("onesign5");
   ObjectDelete("onesign15");
   ObjectDelete("honesign30");
   ObjectDelete("onesign30");
   ObjectDelete("fifty5");
   ObjectDelete("fifty15");
   ObjectDelete("fifty30");
   ObjectDelete("fiftyH1");
   ObjectDelete("fiftyH4");
   ObjectDelete("fiftyD1");
//---
return(0);
}